# Simple Example 2

## read file ##

hold1_df<-read.csv('mc_cart_simpleExample2.csv',header=T)


## OR Simulate##

#install.packages('lavaan')
#install.packages('rattle')
#install.packages('rpart')
library(lavaan)
library(rattle)
library(rpart)

# Replications and Matrix to hold results
rep1=5000
hold1<-matrix(NA,nrow=rep1,ncol=4)

# Start Simulation

for (i in 1:rep1){
n<-sample(50:200,1)
p<-runif(1,.6,.9)

sq_p<-p*p
resid_p<-1-sq_p

model <- '
f1 =~ lambda1*x1
x1 ~~ error*x1
y ~ .14*f1
y ~~ .98*y
f1 ~~ 1*f1'


# Change model to include true values

model<-gsub("lambda1",p,model)
model<-gsub("error",resid_p,model)

#extract fitted covariance
true_cov<-fitted(sem(model))$cov
true_corr<-cov2cor(true_cov)
sampledata<-mvrnorm(n,rep(0,2),Sigma=true_corr)

reg1<-lm(y~x1,data=as.data.frame(sampledata))
pval<-ifelse(summary(reg1)$coefficients[,4][2]<=.05,1,0)
hold1[i,]<-c(n,p,coef(reg1)[2],pval)
}

# Make a dataset
hold1_df<-as.data.frame(hold1)
names(hold1_df)<-c("n","p","bias","pval")


# Fit tree and plot
tree.1<-rpart(pval~n+p,data=hold1_df,control=rpart.control(cp=.005))
fancyRpartPlot(tree.1) 